//-----------------------------------------------------------------
// Klasse fuer die Speicerung der Daten eines Akkus
//-----------------------------------------------------------------
#ifndef akku_included
#define akku_included

#include <qpainter.h>
#include <qpaintd.h>
#include <qlist.h>
#include <stdio.h>
#include <math.h>
#include "messwert.h"
#include "model.h"


//--- hiermit wird eine Liste mit sortierten Messwerten abgeleitet
class QList_akku : public QList<messwert>
{
  int compareItems1(messwert *m1,messwert *m2)
  {
     return (m2->get_zeit() - m1->get_zeit());
  }
};


//--- Hier wird ein Akku mit seiner Messreihe verwaltet
// das ist die Datenklasse 
class akku_model : public model
  {
  private:
    QList_akku messreihe;
    messwert *aktuell;		// der aktuelle Messwert
    messwert::modus status;		// der aktuelle Akkustatus

  public:
    akku_model();
    ~akku_model();
    QList_akku *get_messreihe( void );
    messwert *get_aktuell( void );
    void messwert_anhaengen( messwert *m );
    void messreihe_ausgeben( void );
    int max_spannung( void );
    int min_spannung( void );
    int max_strom( void );
    int min_strom( void );
    int max_zeit( void );
    void messreihe_sichern( const char *filename );
    void messreihe_laden( const char *filename );
    bool messreihe_testen( const char *filename );
    double kapazitaet( void );

  };


#endif   // akku_included
