#include <stdio.h>
#include <math.h>
#include <qdir.h>
#include <qlist.h>
#include <qframe.h>
#include <qpaintd.h>
#include <qpainter.h>
#include <qprinter.h>
#include <qpixmap.h>
#include <qpdevmet.h>
#include <qmsgbox.h>
#include <qcolor.h>
#include <qpen.h>
#include <kurl.h>
#include "akku.h"
#include "akku_draw.h"

void akku_draw::drop( char *d, int , int , int , int )
{
  KURL u(d);
  if(  a->messreihe_testen(u.path()) )
    a->messreihe_laden(u.path());
  else
    QMessageBox::information( this, "Drop Meldung","Das Fileformat entspricht nicht einer Messreihe\nes wird daher nicht geladen" );
}



void akku_draw::moreinit( void )
{
//  printf("Konstruktor aufgerufen\n");
  setFrameStyle( 51 );
  setLineWidth( 2 );
 {
   QColorGroup normal( QColor( QRgb(0) ), QColor( QRgb(16777215) ), QColor( QRgb(16777215) ), QColor( QRgb(6316128) ), QColor( QRgb(10789024) ), QColor( QRgb(0) ), QColor( QRgb(16777215) ) );
   QColorGroup disabled( QColor( QRgb(8421504) ), QColor( QRgb(12632256) ), QColor( QRgb(16777215) ), QColor( QRgb(6316128) ), QColor( QRgb(10789024) ), QColor( QRgb(8421504) ), QColor( QRgb(12632256) ) );
   QColorGroup active( QColor( QRgb(0) ), QColor( QRgb(12632256) ), QColor( QRgb(16777215) ), QColor( QRgb(6316128) ), QColor( QRgb(10789024) ), QColor( QRgb(0) ), QColor( QRgb(16777215) ) );
   QPalette palette( normal, disabled, active );
   setPalette( palette );
  }
  a = NULL;				// vorsichtshalber loeschen
  r = NULL;				// vorsichtshalber loeschen
}

void akku_draw::set_akku( akku_model *ak )
{
  a = ak;				// einfach den Zeiger merken
  ak->add_view(this);			// damit wird der View angemeldet
}

void akku_draw::del_akku( void )
{
  a->del_view(this);			// damit wird der View abgemeldet
  a = NULL;				// der Zeiger ist jetzt ungueltitg
}

void akku_draw::set_referenz_akku( akku_model *ak )
{
  r = ak;				// einfach den Zeiger merken
  repaint(FALSE);			// und neu zeichnen
}

void akku_draw::del_referenz_akku( void )
{
  r = NULL;				// einfach den Zeiger merken
  repaint(FALSE);			// und neu zeichnen
}

void akku_draw::draw_window( QPaintDevice *pd )
{
  char tmp[100];
  int u_min = 1;
  int u_max = 0;
  int i_min = 1;
  int i_max = 0;
  int t_max = 0;

  int strom_aktiv = 1;		// Stromskala aktiv ?

  QPaintDeviceMetrics me(pd);	// Ermitteln der Pixmapgroesse

  if(a)
  {
    u_min = a->min_spannung();
    u_max = a->max_spannung();
    i_min = a->min_strom()-500;
    i_max = a->max_strom();
    i_max *=2;
    t_max = a->max_zeit();
  }
  if(r)
  {				// ist ein Referenzakku angegeben ?
    if(r->min_spannung() < u_min)
      u_min = r->min_spannung();
    if(r->max_spannung() > u_max)
      u_max = r->max_spannung();
    if(r->max_zeit() > t_max)
      t_max = r->max_zeit();
  }

  if(u_max-u_min == 0)
    u_max = u_min+1;
  if(u_max < u_min || t_max == 0)
  {
   u_min = 0;
   u_max = 10000;
   t_max = 500;
  }
  if(i_max-i_min == 0)
    i_max = i_min+1;
  if(i_max < i_min)
  {
   i_min = 0;
   i_max = 1000;
  }

  QList_akku *messreihe = a->get_messreihe();

  QPainter p;
  p.begin( pd );                         // start painting pixmap

//  pd->fill( /* backgroundColor()*/ white );           // initialize pixmap

//  printf("Fenster neu malen w=%d h=%d\n",me.width(),me.height());
//  printf("Minimale Spannung %d Maximale Spannung %d\n",u_min,u_max);

  p.setPen( gray );                        // blue outline

  int merk = 0;
  messwert *m;

  p.setBrush( gray );
  p.setPen( gray );
  p.drawRect(0,0,35,me.height()-25);
  p.setBrush( black );
  p.setPen( black );
  p.drawRect(0,me.height()-25,36,25);

	// diese Masstaebe in mv
  int scales[] =      {1 ,5 ,10 ,20 ,50 ,200 ,500 ,1000 ,2000 ,5000 ,10000 ,20000};
  int scales_main[] = {10,20,100,100,200,1000,2000,10000,10000,20000,100000,100000};
  int range = (u_max - u_min);
  int anz_lines;
  int scale_index=0;			// INdex in die Scale liste

  for(int j=0;j<12;j++)
  {
    anz_lines = range/scales[j];	// Die Anzahl der Linien
    if(anz_lines < (me.height()-25) / 10)
      {
         scale_index = j;
         break;
      }
  }

//  printf("Bitte den Masstab %d verwenden\n",scale_index);

  QColor col(200,200,200);
  QPen pe(col);
  for(int i=u_min/scales[scale_index];i<=u_max/scales[scale_index];i++)
  {
    int y = (me.height()-25) - ((i*scales[scale_index]-u_min)*(me.height()-25))/range;
    if(i*scales[scale_index] % scales_main[scale_index] == 0)
    {
      sprintf(tmp,"%1.1fV",(double)i/1000.0*(double)scales[scale_index] );  
      p.setPen( white );
      p.drawText(2,y+5,tmp);
      p.setPen( black );
    }
    else
      p.setPen( pe );
    p.drawLine(35,y,me.width()-strom_aktiv*35,y);
  }

  p.setBrush( gray );
  p.setPen( gray );
  p.drawRect(36,me.height()-25,me.width()-35-strom_aktiv*35,25);

  int times[] =      {1 ,5 ,10 ,30 ,60 ,300 ,600 ,1800 ,3600 ,7200 ,36000 ,72000};
  int times_main[] = {10,60,60,300 ,600,1800,3600, 3600,36000,36000 ,72000, 72000};
  int anz_times;
  int time_index=0;			// INdex in die Scale liste

  for(int j=0;j<12;j++)
  {
    anz_times = t_max/times[j];	// Die Anzahl der Linien
    if(anz_times < (me.width()-35-strom_aktiv*35) / 7)
      {
         time_index = j;
         break;
      }
  }


  for(int i=0;i<=t_max/times[time_index];i++)
  {
    int x = 35 + ((i*times[time_index])*(me.width()-35-strom_aktiv*35))/(t_max);

    if(i*times[time_index] % times_main[time_index] == 0)
    {
      sprintf(tmp,"%d:%02d",i*times[time_index]/60,i*times[time_index]%60);  
      p.setPen( white );
      p.drawText(x-5,me.height()-10,tmp);
      p.setPen( black );
    }
    else
      p.setPen( pe );
    p.drawLine(x,0,x,me.height()-25);
  }

  if(strom_aktiv)
  {
    QColor str_col(172,120,0);
    QPen str_pe(str_col);
    QBrush str_br(str_col);

    p.setBrush( str_br );
    p.setPen( str_pe );
    p.drawRect(me.width()-35,0,35,me.height()-25);

    p.setBrush( black );
    p.setPen( black );
    p.drawRect(me.width()-35,me.height()-25,35,25);

    int strs[] =      {1 ,5 ,10 ,30 ,60 ,300 ,600 ,1800 ,3600 ,7200 ,36000 ,72000};
    int strs_main[] = {10,60,60,300 ,600,1800,3600, 3600,36000,36000 ,72000, 72000};
    int anz_strs;
    int str_index=0;			// INdex in die Scale liste

    for(int j=0;j<12;j++)
    {
      anz_strs = (i_max-i_min)/strs[j];	// Die Anzahl der Linien
      if(anz_strs < (me.width()-35-strom_aktiv*35) / 30)
        {
           str_index = j;
           break;
        }
    }

    for(int i=i_min/strs[str_index];i<=i_max/strs[str_index]/2;i++)
    {
        int y = (me.height()-25) - ((i*strs[str_index]-i_min)*(me.height()-25))/(i_max-i_min);

        sprintf(tmp,"%2.1f",(float)i/1000.0*(float)strs[str_index]);  
        p.setPen( white );
        p.drawText(me.width()-30,y,tmp);
    }
  }


//----------- Zeichnung beschriften 
  if(a && me.height() > 100 && me.width() > 200 )
  {
    p.setBrush( white );
    p.setPen( black );
    p.drawRect(me.width()-150-strom_aktiv*35,me.height()-90,140,50);

    p.setPen( blue );
    sprintf(tmp,"Kap.: %3.4fAh",a->kapazitaet());  
    p.drawText(me.width()-145-strom_aktiv*35,me.height()-75,tmp);
    sprintf(tmp,"Umax: %3.3fV",u_max/1000.0);  
    p.drawText(me.width()-145-strom_aktiv*35,me.height()-60,tmp);
    sprintf(tmp,"Zeit: %02d:%02d",t_max/60,t_max%60);  
    p.drawText(me.width()-145-strom_aktiv*35,me.height()-45,tmp);
  }

  if(a)
  {
    p.setPen( red );
    for ( m=messreihe->first(); m != 0; m=messreihe->next() )
      {
         int u = m->get_spannung();
         int t = m->get_zeit();
         if(merk == 0)
           p.moveTo(35+(t*(me.width()-40-strom_aktiv*35))/t_max,(me.height()-25) - ((u-u_min)*(me.height()-25))/(u_max-u_min));
         else
           p.lineTo(35+(t*(me.width()-40-strom_aktiv*35))/t_max,(me.height()-25) - ((u-u_min)*(me.height()-25))/(u_max-u_min));
         merk = 1;
      }
  }  // of if(a)
  if(r)
  {
  merk = 0;
  messreihe = r->get_messreihe();
  p.setPen( green );
  for ( m=messreihe->first(); m != 0; m=messreihe->next() )
    {
       int u = m->get_spannung();
       int t = m->get_zeit();
       if(merk == 0)
         p.moveTo(35+(t*(me.width()-40-strom_aktiv*35))/t_max,(me.height()-25) - ((u-u_min)*(me.height()-25))/(u_max-u_min));
       else
         p.lineTo(35+(t*(me.width()-40-strom_aktiv*35))/t_max,(me.height()-25) - ((u-u_min)*(me.height()-25))/(u_max-u_min));
       merk = 1;
    }
  }

  if(strom_aktiv)
  {
    QColor str_col(172,120,0);
    QPen str_pe(str_col);
  merk = 0;
  messreihe = a->get_messreihe();
  p.setPen( str_pe );
  for ( m=messreihe->first(); m != 0; m=messreihe->next() )
    {
       int i = m->get_strom();
       int t = m->get_zeit();
       if(merk == 0)
         p.moveTo(35+(t*(me.width()-40-strom_aktiv*35))/t_max,(me.height()-25) - ((i-i_min)*(me.height()-25))/(i_max-i_min));
       else
         p.lineTo(35+(t*(me.width()-40-strom_aktiv*35))/t_max,(me.height()-25) - ((i-i_min)*(me.height()-25))/(i_max-i_min));
       merk = 1;
    }
  }

  p.end();      

}


void akku_draw::paintEvent( QPaintEvent *e )
{
  
  QPixmap  pm( width()-4,height()-4 );                  // create pixmap
  pm.fill(  white );           // initialize pixmap
  
  draw_window(&pm);					// Fenster auf der Pixmap malen

  bitBlt( this, 2,2, &pm );               // copy pixmap to widget
  QFrame::paintEvent(e);
}

void akku_draw::print( QPrinter *printer )
{
  draw_window(printer);					// Fenster auf der Pixmap malen
}

void akku_draw::model_changed(  )
{
  repaint(FALSE);
}
