//----------------------------------------------------------------------------
// Klasse fuer die Abfrage und Verwaltung des Ladegeraetes
//----------------------------------------------------------------------------
#ifndef ladegeraet_ser_included
#define ladegeraet_ser_included

#include "messwert.h"
#include "optionen.h"
#include "ladegeraet.h"

class ladegeraet_ser : public ladegeraet
{
  public:
	// Das Ladegeraet wird geoeffnet. Die Angaben aus den Optionen sind zu beruecksichtigen
    ladegeraet_ser( optionen *o );
     	// Ladegeraet wird geschlossen, z.B. bei Programmende
    virtual ~ladegeraet_ser( void );

	// wenn ein Messwert vorliegt, ist dieser zurckzugeben, andernfalls ist NULL zurueckzugeben
    messwert *messwert_empfangen( int *akkunr );	// wird zyklisch aufgerufen

  protected:
    virtual void open_ser( optionen *);			// serielle zum Lader oeffnen
    virtual messwert *read_byte( int *akkunr,char c );

    void write_byte( const char  );

  private:
    int ser_fil;			// Filehandle der seriellen Schnittstelle
    struct termios ser_old,ser_new;  	// terio Strukturen fuer ser Schnittstelle

};

#endif
