//----------------------------------------------------------------------------
// Klasse fuer die Abfrage und Verwaltung des Ladegeraetes
//----------------------------------------------------------------------------
#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/time.h> 
#include <fcntl.h>
#include <termios.h>
#include <unistd.h>
#include <qmsgbox.h>

#include "messwert.h"
#include "optionen.h"
#include "ladegeraet.h"
#include "ladegeraet_ser.h"
#include "ladegeraet_ser_conrad.h"

	// Das Ladegeraet wird geoeffnet. Die Angaben aus den Optionen sind zu bercksichtigen
void ladegeraet_ser_conrad::ladegeraet_ser_conrad_init(optionen *)
{
// printf("Konrad_init\n");
  linebuffer_pos = 0;
  state = messwert::stop;
}


     	// Ladegeraet wird geschlossen, z.B. bei Programmende
ladegeraet_ser_conrad::~ladegeraet_ser_conrad( void )
{

}

void ladegeraet_ser_conrad::trigger( void )	// hier wird der Sekundentrigger benoetigt
{
//  printf("Byte an Lader ausgeben \n");
  linebuffer_pos = 0;
  write_byte(0x12);
}

messwert *ladegeraet_ser_conrad::read_byte( int *akkunr,char c )
{
//  printf("Byte empfangen pos=%d: %02X\n",linebuffer_pos,(unsigned char)c);
  linebuffer[linebuffer_pos++] = (unsigned char)c;

  if(linebuffer[0] == 0x12)
  {
    if(linebuffer_pos >= 16)
    {
      memcpy(antwort_12,linebuffer,16);

      linebuffer_pos=0;
      write_byte(0x11);
    }
  }
  if(linebuffer[0] == 0x11)
  {
    if(linebuffer_pos >= 14)
    {
       memcpy(antwort_11,linebuffer,14);
//       printf("Eingestellte Werte empfangen\n");

       linebuffer_pos=0;
       write_byte(0x21);
    }    
  }

  if(linebuffer[0] == 0x21)
  {
    if(linebuffer_pos >= 5)
    {
       memcpy(antwort_21,linebuffer,5);
//       printf("Gemessene Werte empfangen\n");

// jetzt alle Daten auswerten
      int i;

/*----------------------
      printf("Antwort 11 :");
      for(i=0;i<14;i++)
        printf(" %02X",antwort_11[i]);
      printf("\n");

      printf("Antwort 12 :");
      for(i=0;i<16;i++)
        printf(" %02X",antwort_12[i]);
      printf("\n");

      printf("Antwort 21 :");
      for(i=0;i<5;i++)
        printf(" %02X",antwort_21[i]);
      printf("\n");
----------------------*/

      *akkunr=0;			// Conrad Lader hat nur einen Akku
 
      if(antwort_11[2] == 0)		/* kein Fehler gemedet */
      {
        if(antwort_11[1] == 0x81  || antwort_11[1] == 0x82 )    // ist er aktiv ?
        {
          if(state == messwert::stop)
          {
//            printf("************************** START ***********************\n");
	    state = messwert::start;
            aw_merk = antwort_11[1];
            return new messwert(messwert::start);
          }
          if(aw_merk != antwort_11[1])
          {
//            printf("************************** STOP ***********************\n");
            state = messwert::stop;
            aw_merk = antwort_11[1];
            return new messwert(messwert::stop);
          }

          if(antwort_11[1] == 0x81)        // Laden
          {
//            printf("**** Messwert liefern ****\n");

            int spannung = 256*antwort_12[5] + antwort_12[6];
            int zeit = antwort_12[12] + 60*antwort_12[11] + 3600*antwort_12[10];
            int strom = 256*antwort_21[3] + antwort_21[4];
//            printf("Spannung : %d  Strom : %d Zeit %d\n",spannung*5,strom,zeit);
            return new messwert(zeit,strom,spannung*5);
          }
          else 				// entladen
          {
//            printf("**** Messwert liefern ****\n");

            int spannung = 256*antwort_12[5] + antwort_12[6];
            int zeit = antwort_12[9] + 60*antwort_12[8] + 3600*antwort_12[7];
            int strom = 256*antwort_11[8] + antwort_11[9];
//            printf("Spannung : %d  Strom : %d Zeit %d\n",spannung*5,strom,zeit);
            return new messwert(zeit,strom,spannung*5);
          }
        }
        else		// ein anderer Code als 81 uder 82
        {
          if(state == messwert::start)
          {	// nur wenn ueberhaupt eine laeuft
//          printf("************************** STOP ***********************\n");
            state = messwert::stop;
            return new messwert(messwert::stop);
          }
        }
      }
      else
      {		// Fehler wurde gemeldet, egal welcher -> Messreihe stoppen und speichern.
        if(state == messwert::start)
        {	// nur wenn ueberhaupt eine laeuft
//          printf("************************** STOP ***********************\n");
          state = messwert::stop;
          return new messwert(messwert::stop);
        }
      }
    }    
  }

return NULL;
}

