//----------------------------------------------------------------------------
// Klasse fuer die Abfrage und Verwaltung des Ladegeraetes
//----------------------------------------------------------------------------

#ifndef ladegeraet_ser_conrad_included
#define ladegeraet_ser_conrad_included

#include "messwert.h"
#include "optionen.h"
#include "ladegeraet.h"
#include "ladegeraet_ser.h"
#include "ladegeraet_ser_conrad.h"

class ladegeraet_ser_conrad : public ladegeraet_ser
{
  public:
	// Das Ladegeraet wird geoeffnet. Die Angaben aus den Optionen sind zu beruecksichtigen
    ladegeraet_ser_conrad( optionen *o ) : ladegeraet_ser(o)
    {
      ladegeraet_ser_conrad_init(o); 
    };
     	// Ladegeraet wird geschlossen, z.B. bei Programmende
    ~ladegeraet_ser_conrad( void );

    virtual messwert *read_byte( int *akkunr,char c );

  private:
    void ladegeraet_ser_conrad_init(optionen *o);
    unsigned char linebuffer[100];
    int linebuffer_pos;

    unsigned char antwort_11[30];	// Die Antwortmeldungen werden hier gespeichert
    unsigned char antwort_12[30];
    unsigned char antwort_21[30];

    unsigned char aw_merk;		// Merk sich, ob Laden oder Entladen anliegt
    messwert::modus state;				// Merker fuer den Status

    void trigger( void );	// wird hier final ueberladen
};

#endif

