//----------------------------------------------------------------------------
// Klasse fuer die Abfrage und Verwaltung des Ladegeraetes
//----------------------------------------------------------------------------
#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/time.h> 
#include <fcntl.h>
#include <termios.h>
#include <unistd.h>
#include <qmsgbox.h>

#include "messwert.h"
#include "optionen.h"
#include "ladegeraet.h"
#include "ladegeraet_ser.h"
#include "ladegeraet_ser_schulze.h"

	// Das Ladegeraet wird geoeffnet. Die Angaben aus den Optionen sind zu bercksichtigen
void ladegeraet_ser_schulze::ladegeraet_ser_schulze_init(optionen *)
{
printf("Schulze_init\n");
  linebuffer_pos = 0;
}

     	// Ladegeraet wird geschlossen, z.B. bei Programmende
ladegeraet_ser_schulze::~ladegeraet_ser_schulze( void )
{

}

messwert *ladegeraet_ser_schulze::read_byte( int *akkunr,char c )
{
  int zeit,spannung,strom;
  char mode[30]="  ";
  int erg;

  if(c == 0x0a)
    return NULL;
  if(c == 0x0d)
  {
    linebuffer[linebuffer_pos++] = 0;    

    printf("line >%s<\n",linebuffer);
    *akkunr = -1;
    erg = sscanf(linebuffer,"%d:%d:%d:%d%c%c",akkunr,&zeit,&spannung,&strom,&mode[0],&mode[1]);
    
    printf("Akku %d  Zeit %d  Spannung %d  Strom %d  Mode %s\n",*akkunr,zeit,spannung,strom,mode);
    if(mode[0] == '-')
      strom = - strom;	/* das ist entladen */
    linebuffer_pos = 0;
    if(erg >= 4)
    {
      (*akkunr)--;		// zaehlt ab 1, hier aber ab 0 erforderlich
      if(*akkunr >= 0 && *akkunr <= 2)
      {
        messwert::modus md;
        switch(mode[1])
        {
          case 'L' : md = messwert::laden; break;
          case 'l' : md = messwert::laden; break;
          case 'e' : md = messwert::entladen; break;
          case 'E' : md = messwert::entladen; break;
          default:
            return NULL;	// Unbekannte Wertetypen verwerfen
            break;
        }
        messwert *m = new messwert(zeit,strom,spannung);
        return m;
      }
    }
    else
    {
      if(strncmp(linebuffer,"(A",2) == 0)
      {
        if(strstr(linebuffer,"Akku_dran") != NULL)
        {
          printf("************* Akku %d angeschlossen *************\n",linebuffer[2] - 0x30);
          messwert *m = new messwert(messwert::start);
          *akkunr = linebuffer[2] - 0x31;
          return m;
        }
        if(strstr(linebuffer,"Akku_ab") != NULL)
        {
          printf("************* Akku %d abgezogen *************\n",linebuffer[2] - 0x30);
          messwert *m = new messwert(messwert::stop);
          *akkunr = linebuffer[2] - 0x31;
          return m;
        }
        if(strstr(linebuffer,"Akku_leer") != NULL)
        {
          printf("************* Akku %d leer *************\n",linebuffer[2] - 0x30);
          messwert *m = new messwert(messwert::stop);
          *akkunr = linebuffer[2] - 0x31;
          return m;
        }
        if(strstr(linebuffer,"Akku_voll") != NULL)
        {
          printf("************* Akku %d voll *************\n",linebuffer[2] - 0x30);
          messwert *m = new messwert(messwert::stop);
          *akkunr = linebuffer[2] - 0x31;
          return m;
        }
      }
    }
  }
  else
    linebuffer[linebuffer_pos++] = c;    

return NULL;
}

