//----------------------------------------------------------------------------
// Klasse fuer die Abfrage und Verwaltung des Ladegeraetes
//----------------------------------------------------------------------------
#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/time.h> 
#include <fcntl.h>
#include <termios.h>
#include <unistd.h>
#include <qmsgbox.h>

#include "messwert.h"
#include "optionen.h"
#include "ladegeraet.h"

	// Das Ladegeraet wird geoeffnet. Die Angaben aus den Optionen sind zu bercksichtigen
ladegeraet_ser::ladegeraet(optionen *opt)
{
    open_ser(opt);
}

     	// Ladegeraet wird geschlossen, z.B. bei Programmende
ladegeraet_ser::~ladegeraet( void )
{
       close(ser_fil);
}

	// oeffnet die serielle Schnittstelle zum Ladegeraet
void ladegeraet_ser::open_ser(optionen *opt)
{
        ser_fil = open(opt->get_serpath(),O_RDONLY | O_NONBLOCK);
        if(ser_fil >= 0)
        {
//	  tcgetattr(ser_fil,&ser_old);			/* Alte Terminaloptionen holen 		*/
  	  memcpy(&ser_new,&ser_old,sizeof(ser_new));	/* erstmal uebernehmen 			*/

  	  cfsetospeed(&ser_new,B9600);		/* Baudrate anpassen   			*/
  	  cfsetispeed(&ser_new,B9600);
  	  cfmakeraw(&ser_new);			/* raw bedeutet durchzuf fuer alle Zeichen */
  	  tcsetattr(ser_fil,TCSANOW,&ser_new);		/* Terminaloptionen einstellen 		*/
        }
        else
        {
           QMessageBox::information( NULL, "ISL Tool","Die serielle Schnittstelle\nkann nicht geoeffnet werden !" );
           printf("die serielle Schnittstelle kann nicht geoeffnet werden \n");
        }
}

	// wenn ein Messwert vorliegt, ist dieser zurckzugeben, andernfalls ist NULL zurckzugeben
messwert *ladegeraet_ser::messwert_empfangen( int *akkunr )	// wird zyklisch aufgerufen
{
  fd_set 		rdfs;
  struct timeval 	tv;
  int 			erg=0;
  messwert              *m = NULL;

  FD_ZERO(&rdfs);
  FD_SET(ser_fil,&rdfs);
  tv.tv_sec = 0;
  tv.tv_usec = 0;

  if(ser_fil >= 0)
  {
    erg = select(ser_fil+1,&rdfs,NULL,NULL,&tv);
    if(erg >0  &  FD_ISSET(ser_fil,&rdfs) )
    {

      int anz;
      char c;
      do
       {
         anz = read(ser_fil,&c,1);
         if(anz > 0)
           m = read_byte(akkunr,c);
       } while (!m && anz > 0);
    }
  }
  return m;
}

