/**********************************************************************

	--- Qt Architect generated file ---

	File: maindlg.cpp
	Last generated: Sat Oct 10 16:54:34 1998

 *********************************************************************/
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/time.h> 
#include <fcntl.h>
#include <termios.h>
#include <unistd.h>   
#include <stdio.h>
#include <qpainter.h>
#include <qtimer.h>
#include <qmenubar.h>
#include <qlabel.h>
#include <qkeycode.h>
// #include <qapp.h>
//#include <qprinter.h>
// #include <qfiledlg.h> 
#include <kfiledialog.h> 
#include <kdir.h>
#include <qtooltip.h> 
#include <qmsgbox.h>
// #include <qapp.h>
#include <kapp.h>
#include "maindlg.h"
#include "akku.h"
#include "optionen.h"
#include "optionendlg.h"
#include "ueberblick.h"
#include "panelmeter.h"
#include "ladegeraet_ser_schulze.h"
#include "ladegeraet_ser_conrad.h"

#define Inherited maindlgData

maindlg::maindlg
(
	QWidget* parent,
	const char* name
)
	:
	Inherited( parent, name )
{
    opt = new optionen();		// Optionsobjekt anlegen
    opt->laden();				// und Grundeinstellung laden

    ld=NULL;
    open_lader();

    setCaption("Ulrich's Ladegert Auswerter");

    QTimer *timer = new QTimer( this );
    connect( timer, SIGNAL(timeout()),
             this, SLOT(timeout()) );
    timer->start( 100, FALSE );                 // 100 ms repeat

    akku_sel = 0;

    tr_count = 0;
    zeichenfeld->set_akku(&akkudata[akku_sel]);

    QPopupMenu *file = new QPopupMenu();
    CHECK_PTR( file );
    file->insertItem(  "&ffnen ...",  this, SLOT(menue_open()), CTRL+Key_O );
    file->insertItem(  "R&efernz ffnen ...",  this, SLOT(menue_referenz_open()), CTRL+Key_E );
    file->insertItem(  "&Sichern ...", this, SLOT(menue_save()), CTRL+Key_S );
    file->insertSeparator();
    file->insertItem( "&Drucken",  this, SLOT(menue_print()), CTRL+Key_D );
    file->insertItem( "D&rucker Einrichten ...",  this, SLOT(menue_print_setup()), CTRL+Key_R );
    file->insertSeparator();
    file->insertItem( "Q&uit",  kapp, SLOT(quit()), CTRL+Key_Q );

    QPopupMenu *options = new QPopupMenu();
    CHECK_PTR( options );
    options->insertItem(  "&Einstellungen ...",  this, SLOT(menue_setup()), CTRL+Key_I );

    QPopupMenu *view = new QPopupMenu();
    CHECK_PTR( view );
    view->insertItem(  "&Uebersicht ...",  this, SLOT(menue_uebersicht()), CTRL+Key_U );
    view->insertItem(  "Panel&meter ...",  this, SLOT(menue_panelmeter()), CTRL+Key_M );

    QPopupMenu *help = kapp->getHelpMenu( true, "Klader 1.0\n Ladegertauswertesoftware" );    

    menu = new QMenuBar( this );
    CHECK_PTR( menu );
    menu->insertItem( "&Datei", file );
    menu->insertItem( "&Anzeigen", view );
    menu->insertItem( "&Optionen", options );
    menu->insertSeparator();
    menu->insertItem( "&Help", help );

    printer = new QPrinter;                  // create print device
    printer->setOrientation(QPrinter::Landscape);

    QColorGroup normal( QColor( QRgb(0) ), QColor( QRgb(8519680) ), QColor( QRgb(16777215) ), QColor( QRgb(6316128) ), QColor( QRgb(10789024) ), QColor( QRgb(16777215) ), QColor( QRgb(16777215) ) );
    QColorGroup disabled( QColor( QRgb(8421504) ), QColor( QRgb(12632256) ), QColor( QRgb(16777215) ), QColor( QRgb(6316128) ), QColor( QRgb(10789024) ), QColor( QRgb(8421504) ), QColor( QRgb(12632256) ) );
    QColorGroup active( QColor( QRgb(0) ), QColor( QRgb(12632256) ), QColor( QRgb(16777215) ), QColor( QRgb(6316128) ), QColor( QRgb(10789024) ), QColor( QRgb(0) ), QColor( QRgb(16777215) ) );
    
    select_palette = QPalette( normal, disabled, active );
    normal_palette = akku_2->palette();

	// alle drei Akkus (models) werden auf unserem view angezeigt
        // etwas vereinfacht werden einfach alle drei felder neu gezeichnet
    akkudata[0].add_view(this);
    akkudata[1].add_view(this);
    akkudata[2].add_view(this);
}

maindlg::~maindlg()
{
  zeichenfeld->del_akku();	// den Akku aus dem Zeichenfeld herausnehmen
  akkudata[0].del_view(this);	// die Views aus dem Akkuobjekt entfernen
  akkudata[1].del_view(this);
  akkudata[2].del_view(this);
  delete ld;		// ladegeraetobjekt loeschen
  delete printer;       // printerobjekt loeschen
}

void maindlg::timeout()
{
  int akkunr = 0;

  messwert *m = NULL;
  if(ld)
  {
    m = ld->messwert_empfangen( &akkunr );
    if(tr_count++ > 10)	// ca alle Sekunde anwerfen
    {
      ld->trigger( );
      tr_count = 0;
    }
  }
  if(m)
    akkudata[akkunr].messwert_anhaengen(m);
}

void maindlg::open_lader()
{
  switch(opt->get_lader())
  {  
    case 0: ld = new ladegeraet_ser_schulze(opt); break;    	// neues Ladegeraet Objekt erzeugen
    case 1: ld = new ladegeraet_ser_conrad(opt); break;    	// Conrad Lader

    default: ld = NULL;
            QMessageBox::information( this, "ISL Tool","Der Treiber fuer dieses Ladegeraet ist nicht implementiert\nDu bist herzlich eingeladen es zu tun ... !" );
            break;   
  }
}

void maindlg::model_changed( void )
{
  char tmp[100];
   messwert *m;
   m = akkudata[0].get_aktuell();
   if(m)
   {
     sprintf(tmp,"%d:%02d",m->get_zeit()/60,m->get_zeit()%60);
     lb_zeit1->setText(tmp);
     sprintf(tmp,"%3.3f A",m->get_strom()/1000.0);
     lb_strom1->setText(tmp);
     sprintf(tmp,"%3.3f V",m->get_spannung()/1000.0);
     lb_spannung1->setText(tmp);
  }

   m = akkudata[1].get_aktuell();
   if(m)
   {
     sprintf(tmp,"%d:%02d",m->get_zeit()/60,m->get_zeit()%60);
     lb_zeit2->setText(tmp);
     sprintf(tmp,"%3.3f A",m->get_strom()/1000.0);
     lb_strom2->setText(tmp);
     sprintf(tmp,"%3.3f V",m->get_spannung()/1000.0);
     lb_spannung2->setText(tmp);
  }

   m = akkudata[2].get_aktuell();
   if(m)
   {
     sprintf(tmp,"%d:%02d",m->get_zeit()/60,m->get_zeit()%60);
     lb_zeit3->setText(tmp);

     sprintf(tmp,"%3.3f A",m->get_strom()/1000.0);
     lb_strom3->setText(tmp);
     sprintf(tmp,"%3.3f V",m->get_spannung()/1000.0);
     lb_spannung3->setText(tmp);
   }
//  printf("maindlg:Model change erhalten\n");

}
void maindlg::resizeEvent( QResizeEvent * )
{
//  printf("Resize Event\n");
//  zeichenfeld->move(100,100);
  zeichenfeld->resize(width() - 185,height() -35);
}

void maindlg::menue_quit()
{
//  printf("Programm beenden\n");
  KApplication::exit(0);
}

void maindlg::menue_open()
{
//  printf("Menue open\n");

  QString f = KFileDialog::getOpenFileName( QDir::homeDirPath() + "/.lader_messreihen", "*.dat");
    if ( !f.isEmpty() ) 
    {
      akkudata[akku_sel].messreihe_laden( f );
    }
}

void maindlg::menue_referenz_open()
{
//  printf("Menue open\n");

  QString f = KFileDialog::getOpenFileName( QDir::homeDirPath() + "/.lader_messreihen", "*.dat");
    if ( !f.isEmpty() ) 
    {
      referenzakku.messreihe_laden( f );
      zeichenfeld->set_referenz_akku( &referenzakku );  // wird als Referenz mit angezeigt
    }
}

void maindlg::menue_save()
{
  QString f = KFileDialog::getSaveFileName( QDir::homeDirPath() + "/.lader_messreihen", "*.dat" ,0,"messreihe.dat");
    if ( !f.isEmpty() ) 
    {
      akkudata[akku_sel].messreihe_sichern( f );
    }
}

void maindlg::menue_print()
{
  zeichenfeld->print(printer);
}

void maindlg::menue_print_setup()
{
  printer->setup();
}

void maindlg::menue_setup()
{
  optionendlg a;
  a.set_optionen( opt );	/* Felder in den Dialog eintragen */
  a.exec();
  delete ld;
  open_lader();
}

void maindlg::menue_uebersicht()
{
  ueberblick *a = new ueberblick();
  a->akkus_eintragen(&akkudata[0],&akkudata[1],&akkudata[2]);
  a->show();
}

void maindlg::menue_panelmeter()
{
  panelmeter *a = new panelmeter();
  a->akkus_eintragen(&akkudata[akku_sel]);
  a->show();
}

void maindlg::dlg_referenz( bool x )
{
  if(x)		// kreuzchen aktiviert 
  {
  QString f = KFileDialog::getOpenFileName( QDir::homeDirPath() + "/.lader_messreihen", "*.dat" );
    if ( !f.isEmpty() ) 
    {
      referenzakku.messreihe_laden( f );
      zeichenfeld->set_referenz_akku( &referenzakku );  // wird als Referenz mit angezeigt
      zeichenfeld->repaint(FALSE);		// Zeichenfeld neu ausgeben
    }
  }
  else
    zeichenfeld->del_referenz_akku(  );  // wird als Referenz mit angezeigt

}

void maindlg::akku1_sel()
{
zeichenfeld->del_akku();	// alten View aus Zeichenfeld loeschen
if(akku_sel == 1)
  akku_2->setPalette( normal_palette );
else
  akku_3->setPalette( normal_palette );

akku_sel = 0;
zeichenfeld->set_akku(&akkudata[akku_sel]);
akku_1->setPalette( select_palette );
}

void maindlg::akku2_sel()
{
zeichenfeld->del_akku();	// alten View aus Zeichenfeld loeschen
if(akku_sel == 0)
  akku_1->setPalette( normal_palette );
else
  akku_3->setPalette( normal_palette );

akku_sel = 1;
zeichenfeld->set_akku(&akkudata[akku_sel]);
akku_2->setPalette( select_palette );
}

void maindlg::akku3_sel()
{
zeichenfeld->del_akku();	// alten View aus Zeichenfeld loeschen
if(akku_sel == 0)
  akku_1->setPalette( normal_palette );
else
  akku_2->setPalette( normal_palette );

akku_sel = 2;
zeichenfeld->set_akku(&akkudata[akku_sel]);
akku_3->setPalette( select_palette );
}

