//-----------------------------------------------------------------
// Klasse fuer die Speicerung der Daten eines Messwertes
//-----------------------------------------------------------------
#ifndef messwert_included
#define messwert_included

#include <stdio.h>

// diese Klasse fasst einen Messwert
class messwert 
  {
  private:
    int zeit;
    int strom;
    int spannung;

  public:
    enum modus { unbekannt, laden, entladen, messen ,start, stop};

  private:
    modus md ;

  public:
//-------------- ohne Parameter leerer Messwert -------------------
    messwert()
    {
      zeit = 0;
      strom = 0;
      spannung = 0;
      md = unbekannt;
    }
//--------------- mit parametern, normaler messwert ---------------
    messwert(int p_zeit, int p_strom, int p_spannung, enum modus m = unbekannt )
    {
      zeit = p_zeit;
      strom = p_strom;
      spannung = p_spannung;
      md = m;
    }

//--------------- nur Modus, fuer start und stop der Messreihe ---------------
    messwert(enum modus m )
    {
      zeit = 0;
      strom = 0;
      spannung = 0;
      md = m;
    }

  public:
// Inline Memberfunktionen zum lesen und schreiben
    int get_zeit ( void )
      {
        return zeit; 
      }

    int get_spannung( void )
      {
        return spannung; 
      }
    int get_strom( void )
      {
        return strom; 
      }

    modus get_modus( void )
      {
        return md; 
      }

    void print( void );
    void save( FILE *f );

  };

#endif   // messwert_included
