//----------------------------------------------------------------------
// Virtuelle Basisklasse fuer ein Datenmodell
//----------------------------------------------------------------------
#ifndef model_included
#define model_included


#include <qwidget.h>
#include <qlist.h>

class viewer
  {

    public:
		// wird aufgerufen, sobald das Modell eine Aenderung erfahren hat
      virtual void model_changed( void );
  };


class model
  {
    public:
      // Das model soll auf diesem Widget angezeigt werden
      void add_view( viewer * );

      // Die Anzeige wird von dem Widget entfernt
      void del_view( viewer * );

    protected:
      // Diese Funktion dient der abgeleiteten Klasse, eine Aenderung anzuzeigen
      // daraufhin werden die Widgets neu gezeichnet
      void change( void );

    private:
      // Diese Liste verwaltet die Widgets, auf denen das Modell zu sehen ist
      QList<viewer> views;  
    
  };


#endif
